function [f df] = blurObj(params, E, B)

v = reshape(params, 3, length(params)/3); 

if (nargout > 1)
    tic
    [Bv ax ay dBdv1 dBdv2 dBdv3] = blurImage(E, v, 'bilinear');
    toc
else
    [Bv] = blurImage(E, v, 'bilinear');
end

f = sum(sum((B - Bv).^2));

if (nargout > 1)
    dfdBv = -2*(B - Bv);
    dfdv = zeros(3, size(v,2));
    for t = 1:size(v,2)
        M = dfdBv.*dBdv1(:,:,t);
        dfdv(1,t) = sum(sum(M));
        M = dfdBv.*dBdv2(:,:,t);
        dfdv(2,t) = sum(sum(M));
        M = dfdBv.*dBdv3(:,:,t);
        dfdv(3,t) = sum(sum(M));
    end
    df = dfdv(:)';
end
