function v = kernelToTraj(K, steps)

Kv = K(:); 
CKv = zeros(length(Kv), 1);

for n = 2:length(Kv)
    CKv(n) = sum(Kv(1:n-1));    
end

%figure;
%hold on;

samples = []; 
for n = 1:steps
    r = rand;
    idx = find(CKv < r, 1, 'last');

    cidx = floor((idx-1)/size(K,1)) + 1;
    ridx = mod(idx-1,size(K,1)) + 1;
    
    samples = [samples; [cidx -ridx]]; 
 %   plot(cidx, -ridx, 'o'); 
end

%figure; hold on; 
p = [size(K,2)/2, -size(K,1)/2];
for n = 1:steps
    d = samples - repmat(p, size(samples, 1), 1); 
    dist = sum(d.^2,2); 
    [a ii] = min(dist);
    
       % quiver(p(1), p(2), d(ii,1), d(ii,2), 'o');  
    p = p + d(ii,:); 
    v(:,n) = d(ii,:)'; 
    samples(ii,:) = []; 
end