load data; 

% E is the original image
E = imresize(E, 0.1); 
nT = 20; 
nR = size(E, 1); 
nC = size(E, 2); 
% Generate a velocity trajectory representing camera movement
v = randn(3, nT);
v(1:2,:) = v(1:2,:);
%v(1:2,:) = 0.01; 
v(3,:) = 0.01*v(3,:);  % Use a smaller variance for angular velocity 
%v(3,:) = 0; 
%v(3,:) = -0.001; 


% Build matrix A such as blurring amounts to a matrix multiply.  
A = buildBlurMatrix(v, nR, nC); 
U = E(:); 
Q = A*U; 
R = reshape(Q, size(E, 1), size(E, 2)); 

% Ensure the blurring we get from the matrix is consistent with the
% previous blur function.
B = blurImage(E, v, 'bilinear');
max(max(abs(R - B)))


% Visualize kernel matrix at different points in the image
Kvis = zeros(nR, nC); 
step = 10; 
for r = 5:step:nR
    for c = 5:step:nC
        idx = nR*(c - 1) + r;
        K = full(reshape(A(idx,:)', size(E, 1), size(E, 2)));
        Kvis = Kvis + K; 
    end
end

figure; 
subplot(1,3,1); 
imshow(E); 
subplot(1,3,2); 
imshow(Kvis, [0 1/(nT+1)]); 
subplot(1,3,3); 
imshow(R);  

% Try solving for the original image by constrained LSQ
lb = zeros(size(Q)); 
V = lsqlin(A, B(:), [], [], [], [], lb, []); 
Etest = reshape(V, nR, nC); 
max(max(abs(V - U)))